-- font http://www.oracle-base.com/articles/10g/Auditing_10gR2.php
-- executar-ho com usuari administrador

ALTER SYSTEM SET audit_trail = "DB" SCOPE=SPFILE; 
-- s'ha de realitzar un reinici de la base de dades

-- audit de les taules per updates, deletes i inserts

set serveroutput on;
set serveroutput on size 1000000;

DECLARE
vcount1 number := 0;
vcount2 number := 0;
v_tablename varchar2(32);
vschema varchar2(30) := 'manteniment';

BEGIN

vschema := UPPER(vschema);

for ctable in ( select owner, table_name from dba_tables where owner like vschema )
loop
vcount1:= vcount1+1;
v_tablename := ctable.table_name;
begin
dbms_output.put_line(ctable.owner||'."'||ctable.table_name||'"');
execute immediate 'AUDIT UPDATE,DELETE,INSERT ON '||ctable.owner||'."'||ctable.table_name||'" by access';
EXCEPTION -- exception handlers begin
WHEN OTHERS THEN -- handles all other errors
dbms_output.put_line('err_num: '||SQLCODE);
dbms_output.put_line('err_msg: '||SUBSTR(SQLERRM, 1, 100));
dbms_output.put_line('table_name: '||v_tablename);
vcount1:= vcount1-1;
END;
end loop;

dbms_output.put_line('-- ');
dbms_output.put_line('Counter Tables is: '||vcount1);
dbms_output.put_line('-- ');

END;
/
 

-- I ara implementarem el FGA per les taules de MANTENIMENT 

set serveroutput on;
set serveroutput on size 1000000;

DECLARE
vcount1 number := 0;
vcount2 number := 0;
v_tablename varchar2(32);
vschema varchar2(30) := 'manteniment';
BEGIN
vschema := UPPER(vschema);
for ctable in ( select owner, table_name from dba_tables where owner like vschema )
loop
vcount1:= vcount1+1;
v_tablename := ctable.table_name;
begin
dbms_output.put_line(ctable.owner||'."'||ctable.table_name||'"');
execute immediate 'dbms_fga.add_policy (object_schema => 'FGA', object_name => '||ctable.owner||'."'||ctable.table_name||'" , policy_name => 'TABLE_ '||ctable.table_name||'_POLICY',enable => TRUE, ||ctable.table_name||';
EXCEPTION -- exception handlers begin
WHEN OTHERS THEN -- handles all other errors
dbms_output.put_line('err_num: '||SQLCODE);
dbms_output.put_line('err_msg: '||SUBSTR(SQLERRM, 1, 100));
dbms_output.put_line('table_name: '||v_tablename);
vcount1:= vcount1-1;
END;
end loop;
dbms_output.put_line('-- ');
dbms_output.put_line('Counter Tables is: '||vcount1);
dbms_output.put_line('-- ');
END;
/