--
-- Drop and Create Script 
--   Database Version   : 10.2.0.1.0 
--   TOAD Version       : 9.0.0.160 
--   DB Connect String  : XE 
--   Schema             : MANTENIMENT 
--   Script Created by  : MANTENIMENT 
--   Script Created at  : 13/12/2011 16:36:37 
--   Physical Location  :  
--   Notes              :  
--

-- Object Counts: 
--   Tables: 3          Constraints: 4      


ALTER TABLE "aparell"
  DROP CONSTRAINT VERIFICAR_DATES_APARELL
/

ALTER TABLE "aparell"
  DROP CONSTRAINT VERIFICAR_DATES_GARANTIA
/

ALTER TABLE "aparell" ADD (
  CONSTRAINT VERIFICAR_DATES_APARELL
 CHECK ("data_compra"<"data_baixa"),
  CONSTRAINT VERIFICAR_DATES_GARANTIA
 CHECK ("data_inici_garantia" < "data_fi_garantia"))
/

ALTER TABLE "contracte"
  DROP CONSTRAINT VERIFICAR_DATES_CONTRACTE
/

ALTER TABLE "contracte" ADD (
  CONSTRAINT VERIFICAR_DATES_CONTRACTE
 CHECK ("data_inici" < "data_fi"))
/

ALTER TABLE "requeriment_manteniment"
  DROP CONSTRAINT VERIFICAR_DATES_REQUERIMENT
/

ALTER TABLE "requeriment_manteniment" ADD (
  CONSTRAINT VERIFICAR_DATES_REQUERIMENT
 CHECK ("data_inici" < "data_fi"))
/

CREATE OR REPLACE TRIGGER "t_contrate"
BEFORE INSERT ON "contracte" 
REFERENCING OLD AS OLD NEW AS NEW 
FOR EACH ROW 
DECLARE
CURSOR C_CONTRACTE IS SELECT * FROM "contracte" WHERE "id_aparell"= :new."id_aparell";
BEGIN
for L_CONTRACTE in C_CONTRACTE loop
  IF ((:new."data_inici" between L_CONTRACTE."data_inici" and L_CONTRACTE."data_fi")
  or (:new."data_fi" between L_CONTRACTE."data_inici" and L_CONTRACTE."data_fi"))
  THEN
  raise_application_error(-20600,'No es pot introduir unes dates de contracte per un aparell que ja t en aquest perode un contracte vigent');
  end if;
  end loop;
END;
/

create or replace
TRIGGER "t_manteniment"
BEFORE INSERT ON "manteniment_preventiu" 
REFERENCING OLD AS OLD NEW AS NEW 
FOR EACH ROW 
DECLARE
CURSOR C_CONTRACTE IS SELECT * FROM "contracte" WHERE "id_aparell"= :new."id_aparell";
BEGIN
for L_CONTRACTE in C_CONTRACTE loop
  IF not (:new."data_manteniment" between L_CONTRACTE."data_inici" and L_CONTRACTE."data_fi")
  THEN
  raise_application_error(-20600,'No es pot introduir un manteniment per un aparell que no t en aquesta data un contracte vigent amb una empresa de manteniment');
  end if;
  end loop;
END;
/
