--
-- Create Schema Script 
--   Database Version   : 10.2.0.1.0 
--   TOAD Version       : 9.0.0.160 
--   DB Connect String  : XE 
--   Schema             : MANTENIMENT 
--   Script Created by  : MANTENIMENT 
--   Script Created at  : 13/12/2011 16:17:14 
--   Physical Location  :  
--   Notes              :  
--

-- Object Counts: 
--   Functions: 4       Lines of Code: 177 
--   Indexes: 15        Columns: 15         
--   Procedures: 47     Lines of Code: 1610 
--   Sequences: 15 


CREATE SEQUENCE "seq_id_adrea"
  START WITH 241
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_aparell"
  START WITH 61
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_centre_treball"
  START WITH 61
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_contracte"
  START WITH 1
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_empleat"
  START WITH 101
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_empresa_manteniment"
  START WITH 101
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_manteniment_correctiu"
  START WITH 61
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_manteniment_preventiu"
  START WITH 1
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_pais"
  START WITH 181
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_poblacio"
  START WITH 181
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_provincia"
  START WITH 181
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_requeriment_manteniment"
  START WITH 81
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_tecnic"
  START WITH 101
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_tipus_aparell"
  START WITH 101
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE SEQUENCE "seq_id_tipus_via"
  START WITH 181
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "actualitzar_registre_taula" (
   id_clau         NUMBER,
   nom_taula       NVARCHAR2,
   nom_columna     NVARCHAR2,
   valor_columna   NVARCHAR2
)
IS
   stmt                   VARCHAR2 (2000);
   valor_columna_number   NUMBER;
   valor_columna_date     DATE;
   columna                NVARCHAR2 (50);
   taula                  NVARCHAR2 (50);
   tipus_columna          VARCHAR (30);
   clau_primaria          NVARCHAR2 (50);
   clau                   NVARCHAR2 (50);
BEGIN
   tipus_columna := "tipus_columna" (nom_taula, nom_columna);
   clau_primaria := "nom_clau_primaria" (nom_taula);
   clau := dbms_assert.enquote_name ('"' || clau_primaria || '"');
   columna := dbms_assert.enquote_name ('"' || nom_columna || '"');
   taula := dbms_assert.enquote_name ('"' || nom_taula || '"');

   IF (tipus_columna = 'NUMBER')
   THEN
      valor_columna_number := TO_NUMBER (valor_columna);
      stmt :=
            'UPDATE'
         || dbms_assert.simple_sql_name (taula)
         || 'SET '
         || columna
         || '= '
         || valor_columna_number
         || ' where '
         || clau
         || '= :id_taula';

      EXECUTE IMMEDIATE stmt
                  USING id_clau;
   ELSIF (tipus_columna = 'DATE')
   THEN
      valor_columna_date := TO_DATE (valor_columna, 'DD-MM-YYYY');
      stmt :=
            'UPDATE'
         || dbms_assert.simple_sql_name (taula)
         || 'SET '
         || columna
         || '= '
         || valor_columna_date
         || ' where '
         || clau
         || '= :id_clau';
   ELSE
      stmt :=
            'UPDATE'
         || dbms_assert.simple_sql_name (taula)
         || 'SET '
         || columna
         || '= :valor_columna where '
         || clau
         || ' like :id_clau';

      EXECUTE IMMEDIATE stmt
                  USING valor_columna, id_clau;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "actualitzar_registre_taula";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_adrea_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "adrea"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "adrea"
    WHERE "id_adre" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_adrea_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_adreces" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."adrea_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "adrea";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_adrea'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "adrea"
                WHERE "id_adre" = TO_NUMBER (valor_columna);
         WHEN 'nom_via'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "adrea"
                WHERE "nom_via" = INITCAP (valor_columna);
         WHEN 'numero'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "adrea"
                WHERE "numero" = valor_columna;
         WHEN 'codi_postal'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "adrea"
                WHERE "codi_postal" = valor_columna;
         WHEN 'pis'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "adrea"
                WHERE "pis" = valor_columna;
         WHEN 'porta'
         THEN
            IF (valor_columna = '-1')
            THEN
               raise_application_error (-20001,
                                        'Introdueix valor de columna');
            ELSE
               OPEN registres_cursor FOR
                  SELECT *
                    FROM "adrea"
                   WHERE "porta" = valor_columna;
            END IF;
         WHEN 'id_pobl'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "adrea"
                WHERE "id_pobl" = TO_NUMBER (valor_columna);
         WHEN 'id_tipus_via'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "adrea"
                WHERE "id_tipus_via" = TO_NUMBER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_adreces";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_aparell_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "aparell"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "aparell"
    WHERE "id_aparell" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_aparell_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_aparells" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."aparell_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "aparell";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_aparell'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "aparell"
                WHERE "id_aparell" = TO_NUMBER (valor_columna);
         WHEN 'id_tipus_aparell'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "aparell"
                WHERE "id_tipus_aparell" = TO_NUMBER (valor_columna);
         WHEN 'id_centre_treball'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "aparell"
                WHERE "id_centre_treball" = TO_NUMBER (valor_columna);
         WHEN 'marca'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "aparell"
                WHERE "marca" = INITCAP (valor_columna);
         WHEN 'model'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "aparell"
                WHERE "model" = INITCAP (valor_columna);
         WHEN 'data_compra'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "aparell"
                WHERE "data_compra" = TO_DATE (valor_columna, 'DD-MM-YYYY');
         WHEN 'numero_serie'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "aparell"
                WHERE "numero_serie" = valor_columna;
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_aparells";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_centre_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "centre_treball"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "centre_treball"
    WHERE "id_centre_treball" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_centre_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_centre_treballs" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."centre_treball_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "centre_treball";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_centre_treball'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "centre_treball"
                WHERE "id_centre_treball" = TO_NUMBER (valor_columna);
         WHEN 'nom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "centre_treball"
                WHERE "nom" = INITCAP (valor_columna);
         WHEN 'telefon'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "centre_treball"
                WHERE "telefon" = valor_columna;
         WHEN 'correu_electronic'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "centre_treball"
                WHERE "correu_electronic" = LOWER (valor_columna);
         WHEN 'id_adre'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "centre_treball"
                WHERE "id_adre" = TO_NUMBER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_centre_treballs";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_contracte_per_clau" (
   id_clau    IN       NUMBER := NULL,
   registre   OUT      "contracte"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "contracte"
    WHERE "id_contracte" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_contracte_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_contractes" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."contracte_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "contracte";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_contracte'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "contracte"
                WHERE "id_contracte" = TO_NUMBER (valor_columna);
         WHEN 'data_inici'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "contracte"
                WHERE "data_inici" = TO_DATE (valor_columna, 'DD-MM-YYYY');
         WHEN 'data_fi'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "contracte"
                WHERE "data_fi" = TO_DATE (valor_columna, 'DD-MM-YYYY');
         WHEN 'id_aparell'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "contracte"
                WHERE "id_aparell" = TO_NUMBER (valor_columna);
         WHEN 'id_empr_mant'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "contracte"
                WHERE "id_empr_mant" = TO_NUMBER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_contractes";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_empleat_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "empleat"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "empleat"
    WHERE "id_empleat" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_empleat_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_empleats" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."empleat_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "empleat";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_empleat'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empleat"
                WHERE "id_empleat" = TO_NUMBER (valor_columna);
         WHEN 'nom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empleat"
                WHERE "nom" = INITCAP (valor_columna);
         WHEN 'primer_cognom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empleat"
                WHERE "primer_cognom" = INITCAP (valor_columna);
         WHEN 'segon_cognom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empleat"
                WHERE "segon_cognom" = INITCAP (valor_columna);
         WHEN 'nif'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empleat"
                WHERE "NIF" = valor_columna;
         WHEN 'telefon'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empleat"
                WHERE "telefon" = valor_columna;
         WHEN 'id_adre'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empleat"
                WHERE "id_adre" = TO_NUMBER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_empleats";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_empreses_manteniment" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."empresa_manteniment_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "empresa_manteniment";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_empr_mant'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empresa_manteniment"
                WHERE "id_empr_mant" = TO_NUMBER (valor_columna);
         WHEN 'nom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empresa_manteniment"
                WHERE "nom" = INITCAP (valor_columna);
         WHEN 'nif'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empresa_manteniment"
                WHERE "NIF" = valor_columna;
         WHEN 'telefon'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empresa_manteniment"
                WHERE "telefon" = valor_columna;
         WHEN 'id_adre'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "empresa_manteniment"
                WHERE "id_adre" = TO_NUMBER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_empreses_manteniment";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_empr_mant_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "empresa_manteniment"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "empresa_manteniment"
    WHERE "id_empr_mant" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_empr_mant_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_mant_correctius" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."manteniment_correctiu_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "manteniment_correctiu";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_mant_correct'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_correctiu"
                WHERE "id_mant_correct" = TO_NUMBER (valor_columna);
         WHEN 'prioritat'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_correctiu"
                WHERE "prioritat" = UPPER (valor_columna);
         WHEN 'data_incidencia'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_correctiu"
                WHERE "data_incidencia" =
                                        TO_DATE (valor_columna, 'DD-MM-YYYY');
         WHEN 'data_manteniment'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_correctiu"
                WHERE "data_manteniment" =
                                        TO_DATE (valor_columna, 'DD-MM-YYYY');
         WHEN 'id_tecnic'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_correctiu"
                WHERE "id_tecnic" = TO_NUMBER (valor_columna);
         WHEN 'id_aparell'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_correctiu"
                WHERE "id_aparell" = TO_NUMBER (valor_columna);
         WHEN 'id_empr_mant'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_correctiu"
                WHERE "id_empr_mant" = TO_NUMBER (valor_columna);
         WHEN 'id_empleat'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_correctiu"
                WHERE "id_empleat" = TO_NUMBER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_mant_correctius";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_mant_corrt_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "manteniment_correctiu"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "manteniment_correctiu"
    WHERE "id_mant_correct" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_mant_corrt_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_mant_preventius" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."manteniment_preventiu_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "manteniment_preventiu";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_mant_prev'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_preventiu"
                WHERE "id_mant_prev" = TO_NUMBER (valor_columna);
         WHEN 'id_aparell'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_preventiu"
                WHERE "id_aparell" = TO_NUMBER (valor_columna);
         WHEN 'data_manteniment'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_preventiu"
                WHERE "data_manteniment" =
                                        TO_DATE (valor_columna, 'DD-MM-YYYY');
         WHEN 'id_tecnic'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "manteniment_preventiu"
                WHERE "id_tecnic" = TO_NUMBER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_mant_preventius";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_mant_prev_per_clau" (
   id_clau    IN       NUMBER := NULL,
   registre   OUT      "manteniment_preventiu"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "manteniment_preventiu"
    WHERE "id_mant_prev" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_mant_prev_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_paisos" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."pais_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "pais";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_pais'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "pais"
                WHERE "id_pais" = TO_NUMBER (valor_columna);
         WHEN 'nom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "pais"
                WHERE "nom" = INITCAP (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_paisos";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_pais_per_clau" (
   id_clau    IN       NUMBER := NULL,
   registre   OUT      "pais"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "pais"
    WHERE "id_pais" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_pais_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_poblacions" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."poblacio_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "poblacio";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_pobl'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "poblacio"
                WHERE "id_pobl" = TO_NUMBER (valor_columna);
         WHEN 'nom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "poblacio"
                WHERE "nom" = INITCAP (valor_columna);
         WHEN 'id_prov'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "poblacio"
                WHERE "id_prov" = TO_NUMBER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_poblacions";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_poblacio_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "poblacio"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "poblacio"
    WHERE "id_pobl" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_poblacio_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_provincia_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "provincia"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "provincia"
    WHERE "id_prov" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_provincia_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_provincies" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."provincia_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "provincia";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_prov'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "provincia"
                WHERE "id_prov" = TO_NUMBER (valor_columna);
         WHEN 'nom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "provincia"
                WHERE "nom" = INITCAP (valor_columna);
         WHEN 'id_pais'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "provincia"
                WHERE "id_pais" = TO_NUMBER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_provincies";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_req_mant_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "requeriment_manteniment"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "requeriment_manteniment"
    WHERE "id_req_mant" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_req_mant_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_requeriments_mant" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."requeriment_manteniment_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "requeriment_manteniment";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_req_mant'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "requeriment_manteniment"
                WHERE "id_req_mant" = TO_NUMBER (valor_columna);
         WHEN 'data_inici'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "requeriment_manteniment"
                WHERE "data_inici" = TO_DATE (valor_columna, 'DD-MM-YYYY');
         WHEN 'data_fi'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "requeriment_manteniment"
                WHERE "data_fi" = TO_DATE (valor_columna, 'DD-MM-YYYY');
         WHEN 'id_tipus_aparell'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "requeriment_manteniment"
                WHERE "id_tipus_aparell" = TO_NUMBER (valor_columna);
         WHEN 'periocitat'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "requeriment_manteniment"
                WHERE "periocitat" = UPPER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_requeriments_mant";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_tecnic_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "tecnic"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "tecnic"
    WHERE "id_tecnic" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_tecnic_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_tecnics" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."tecnic_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "tecnic";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_tecnic'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tecnic"
                WHERE "id_tecnic" = TO_NUMBER (valor_columna);
         WHEN 'nom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tecnic"
                WHERE "nom" = INITCAP (valor_columna);
         WHEN 'primer_cognom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tecnic"
                WHERE "primer_cognom" = INITCAP (valor_columna);
         WHEN 'segon_cognom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tecnic"
                WHERE "segon_cognom" = INITCAP (valor_columna);
         WHEN 'nif'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tecnic"
                WHERE "NIF" = valor_columna;
         WHEN 'telefon'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tecnic"
                WHERE "telefon" = valor_columna;
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_tecnics";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_tipus_aparells" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."tipus_aparell_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "tipus_aparell";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_tipus_aparell'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tipus_aparell"
                WHERE "id_tipus_aparell" = TO_NUMBER (valor_columna);
         WHEN 'nom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tipus_aparell"
                WHERE "nom" = LOWER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_tipus_aparells";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_tipus_apar_per_clau" (
   id_clau    IN       NUMBER := NULL,
   registre   OUT      "tipus_aparell"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "tipus_aparell"
    WHERE "id_tipus_aparell" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_tipus_apar_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_tipus_via_per_clau" (
   id_clau    IN       NUMBER,
   registre   OUT      "tipus_via"%ROWTYPE
)
IS
BEGIN
   SELECT *
     INTO registre
     FROM "tipus_via"
    WHERE "id_tipus_via" = id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_tipus_via_per_clau";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "consultar_tipus_vies" (
   nom_columna              NVARCHAR2 DEFAULT '-1',
   valor_columna            NVARCHAR2 DEFAULT '-1',
   registres_cursor   OUT   "consultes_cursors"."tipus_via_cursor"
)
IS
BEGIN
   IF (valor_columna = '-1')
   THEN
      IF (nom_columna = '-1')
      THEN
         OPEN registres_cursor FOR
            SELECT *
              FROM "tipus_via";
      END IF;
   ELSE
      CASE LOWER (nom_columna)
         WHEN 'id_tipus_via'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tipus_via"
                WHERE "id_tipus_via" = TO_NUMBER (valor_columna);
         WHEN 'nom'
         THEN
            OPEN registres_cursor FOR
               SELECT *
                 FROM "tipus_via"
                WHERE "nom" = LOWER (valor_columna);
         ELSE
            raise_application_error (-20001, 'columna no vlida');
      END CASE;
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "consultar_tipus_vies";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "esborrar_registre_taula" (id_clau NUMBER, nom_taula NVARCHAR2)
IS
   stmt            VARCHAR2 (2000);
   taula           NVARCHAR2 (50);
   clau_primaria   NVARCHAR2 (50);
   clau            NVARCHAR2 (50);
BEGIN
   clau_primaria := "nom_clau_primaria" (nom_taula);
   clau := dbms_assert.enquote_name ('"' || clau_primaria || '"');
   taula := dbms_assert.enquote_name ('"' || nom_taula || '"');
   stmt :=
         'DELETE FROM'
      || dbms_assert.simple_sql_name (taula)
      || 'where '
      || clau
      || ' like :id_clau';
   DBMS_OUTPUT.put_line (stmt);

   EXECUTE IMMEDIATE stmt
               USING id_clau;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "esborrar_registre_taula";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_adrea" (
   id_adre        OUT   NUMBER,
   nom_via              NVARCHAR2,
   numero               NVARCHAR2,
   codi_postal          NVARCHAR2,
   pis                  VARCHAR2 DEFAULT NULL,
   porta                VARCHAR2 DEFAULT NULL,
   id_pobl              NUMBER,
   id_tipus_via         NUMBER
)
IS
BEGIN
   id_adre := "generar_clau_primaria" ('seq_id_adrea');

   INSERT INTO "adrea"
               ("id_adre", "nom_via", "numero", "codi_postal", "pis",
                "porta", "id_pobl", "id_tipus_via"
               )
        VALUES (id_adre, INITCAP (nom_via), numero, codi_postal, pis,
                porta, id_pobl, id_tipus_via
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_adrea";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_aparell" (
   id_aparell            OUT   NUMBER,
   id_tipus_aparell            NUMBER,
   id_centre_treball           NUMBER,
   marca                       NVARCHAR2,
   model_aparell               NVARCHAR2,
   data_compra                 VARCHAR2,
   data_inici_garantia         VARCHAR2 DEFAULT NULL,
   data_fi_garantia            VARCHAR2 DEFAULT NULL,
   numero_serie                NVARCHAR2 DEFAULT NULL,
   observacions                NVARCHAR2 DEFAULT NULL,
   data_baixa                  VARCHAR2 DEFAULT NULL
)
IS
BEGIN
   id_aparell := "generar_clau_primaria" ('seq_id_aparell');

   INSERT INTO "aparell"
               ("id_aparell", "id_tipus_aparell", "id_centre_treball",
                "marca", "model",
                "data_compra",
                "data_inici_garantia",
                "data_fi_garantia", "numero_serie",
                "observacions", "data_baixa"
               )
        VALUES (id_aparell, id_tipus_aparell, id_centre_treball,
                INITCAP (marca), model_aparell,
                TO_DATE (data_compra, 'DD-MM-YYYY'),
                TO_DATE (data_inici_garantia, 'DD-MM-YYYY'),
                TO_DATE (data_fi_garantia, 'DD-MM-YYYY'), numero_serie,
                observacions, TO_DATE (data_baixa, 'DD-MM-YYYY')
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_aparell";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_centre_treball" (
   id_centre_treball   OUT   NUMBER,
   nom                       VARCHAR2,
   telefon                   VARCHAR2 DEFAULT NULL,
   correu_electronic         VARCHAR2,
   id_adre                   NUMBER
)
IS
BEGIN
   id_centre_treball := "generar_clau_primaria" ('seq_id_centre_treball');

   INSERT INTO "centre_treball"
               ("id_centre_treball", "nom", "telefon",
                "correu_electronic", "id_adre"
               )
        VALUES (id_centre_treball, INITCAP (nom), telefon,
                correu_electronic, id_adre
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_centre_treball";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_contracte" (
   id_contracte   OUT   NUMBER,
   data_inici           VARCHAR2,
   data_fi              VARCHAR2 DEFAULT NULL,
   id_aparell           NUMBER,
   id_empr_mant         NUMBER
)
IS
BEGIN
   id_contracte := "generar_clau_primaria" ('seq_id_contracte');

   INSERT INTO "contracte"
               ("id_contracte", "data_inici",
                "data_fi", "id_aparell", "id_empr_mant"
               )
        VALUES (id_contracte, TO_DATE (data_inici, 'DD-MM-YYYY'),
                TO_DATE (data_fi, 'DD-MM-YYYY'), id_aparell, id_empr_mant
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_contracte";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_empleat" (
   id_empleat      OUT   NUMBER,
   nom                   NVARCHAR2,
   primer_cognom         NVARCHAR2,
   segon_cognom          NVARCHAR2,
   nif                   VARCHAR2,
   telefon               VARCHAR2 DEFAULT NULL,
   id_adre               NUMBER
)
IS
BEGIN
   id_empleat := "generar_clau_primaria" ('seq_id_empleat');

   INSERT INTO "empleat"
               ("id_empleat", "nom", "primer_cognom",
                "segon_cognom", "NIF", "telefon", "id_adre"
               )
        VALUES (id_empleat, INITCAP (nom), INITCAP (primer_cognom),
                INITCAP (segon_cognom), nif, telefon, id_adre
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_empleat";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_empresa_manteniment" (
   id_empr_mant   OUT   NUMBER,
   nom                  NVARCHAR2,
   nif                  VARCHAR2,
   telefon              VARCHAR2 DEFAULT NULL,
   id_adre              NUMBER
)
IS
BEGIN
   id_empr_mant := "generar_clau_primaria" ('seq_id_empresa_manteniment');

   INSERT INTO "empresa_manteniment"
               ("id_empr_mant", "nom", "NIF", "telefon", "id_adre"
               )
        VALUES (id_empr_mant, INITCAP (nom), nif, telefon, id_adre
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_empresa_manteniment";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_manteniment_correctiu" (
   id_mant_correct    OUT   NUMBER,
   prioritat                NVARCHAR2,
   data_incidencia          VARCHAR2,
   data_manteniment         VARCHAR2 DEFAULT NULL,
   id_tecnic                NUMBER DEFAULT NULL,
   id_aparell               NUMBER,
   id_empr_mant             NUMBER,
   id_empleat               NUMBER
)
IS
BEGIN
   id_mant_correct :=
                     "generar_clau_primaria" ('seq_id_manteniment_correctiu');

   INSERT INTO "manteniment_correctiu"
               ("id_mant_correct", "prioritat",
                "data_incidencia",
                "data_manteniment", "id_tecnic",
                "id_aparell", "id_empr_mant", "id_empleat"
               )
        VALUES (id_mant_correct, UPPER (prioritat),
                TO_DATE (data_incidencia, 'DD-MM-YYYY'),
                TO_DATE (data_manteniment, 'DD-MM-YYYY'), id_tecnic,
                id_aparell, id_empr_mant, id_empleat
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_manteniment_correctiu";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_manteniment_preventiu" (
   id_mant_prev       OUT   NUMBER,
   id_aparell               NUMBER,
   data_manteniment         VARCHAR2,
   observacions             NVARCHAR2 DEFAULT NULL,
   id_tecnic                NUMBER DEFAULT NULL
)
IS
BEGIN
   id_mant_prev := "generar_clau_primaria" ('seq_id_manteniment_preventiu');

   INSERT INTO "manteniment_preventiu"
               ("id_mant_prev", "id_aparell",
                "data_manteniment", "observacions",
                "id_tecnic"
               )
        VALUES (id_mant_prev, id_aparell,
                TO_DATE (data_manteniment, 'DD-MM-YYYY'), observacions,
                id_tecnic
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_manteniment_preventiu";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_pais" (id_pais OUT NUMBER, nom VARCHAR2)
IS
BEGIN
   id_pais := "generar_clau_primaria" ('seq_id_pais');

   INSERT INTO "pais"
               ("id_pais", "nom"
               )
        VALUES (id_pais, INITCAP (nom)
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_pais";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_poblacio" (id_pobl OUT NUMBER, nom VARCHAR2, id_prov NUMBER)
IS
BEGIN
   id_pobl := "generar_clau_primaria" ('seq_id_poblacio');

   INSERT INTO "poblacio"
               ("id_pobl", "nom", "id_prov"
               )
        VALUES (id_pobl, INITCAP (nom), id_prov
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_poblacio";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_provincia" (id_prov OUT NUMBER, nom VARCHAR2, id_pais NUMBER)
IS
BEGIN
   id_prov := "generar_clau_primaria" ('seq_id_provincia');

   INSERT INTO "provincia"
               ("id_prov", "nom", "id_pais"
               )
        VALUES (id_prov, INITCAP (nom), id_pais
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_provincia";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_requeriment_mant" (
   id_req_mant        OUT   NUMBER,
   periocitat               NVARCHAR2,
   descripcio               NVARCHAR2 DEFAULT NULL,
   data_inici               VARCHAR2 DEFAULT NULL,
   data_fi                  VARCHAR2 DEFAULT NULL,
   id_tipus_aparell         NUMBER
)
IS
BEGIN
   id_req_mant := "generar_clau_primaria" ('seq_id_requeriment_manteniment');

   INSERT INTO "requeriment_manteniment"
               ("id_req_mant", "periocitat", "descripcio",
                "data_inici",
                "data_fi", "id_tipus_aparell"
               )
        VALUES (id_req_mant, UPPER (periocitat), descripcio,
                TO_DATE (data_inici, 'DD-MM-YYYY'),
                TO_DATE (data_fi, 'DD-MM-YYYY'), id_tipus_aparell
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_requeriment_mant";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_tecnic" (
   id_tecnic       OUT   NUMBER,
   nom                   NVARCHAR2,
   primer_cognom         NVARCHAR2,
   segon_cognom          NVARCHAR2,
   nif                   VARCHAR2,
   telefon               VARCHAR2 DEFAULT NULL
)
IS
BEGIN
   id_tecnic := "generar_clau_primaria" ('seq_id_tecnic');

   INSERT INTO "tecnic"
               ("id_tecnic", "nom", "primer_cognom",
                "segon_cognom", "NIF", "telefon"
               )
        VALUES (id_tecnic, INITCAP (nom), INITCAP (primer_cognom),
                INITCAP (segon_cognom), nif, telefon
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_tecnic";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_tipus_aparell" (
   id_tipus_aparell   OUT   NUMBER,
   nom                      NVARCHAR2,
   descripcio               NVARCHAR2 DEFAULT NULL
)
IS
BEGIN
   id_tipus_aparell := "generar_clau_primaria" ('seq_id_tipus_aparell');

   INSERT INTO "tipus_aparell"
               ("id_tipus_aparell", "nom", "descripcio"
               )
        VALUES (id_tipus_aparell, LOWER (nom), descripcio
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_tipus_aparell";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
PROCEDURE "inserir_tipus_via" (id_tipus_via OUT NUMBER, nom NVARCHAR2)
IS
BEGIN
   id_tipus_via := "generar_clau_primaria" ('seq_id_tipus_via');

   INSERT INTO "tipus_via"
               ("id_tipus_via", "nom"
               )
        VALUES (id_tipus_via, LOWER (nom)
               );
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "inserir_tipus_via";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
FUNCTION "generar_clau_primaria" (nom_sequencia IN VARCHAR2)
   RETURN NUMBER
IS
   PRAGMA AUTONOMOUS_TRANSACTION;
   id_value    NUMBER;
   STATEMENT   VARCHAR2 (2000);
   sequencia   NVARCHAR2 (50);
BEGIN
   sequencia := dbms_assert.enquote_name ('"' || nom_sequencia || '"');
-- Build and run dynamic SQL in a PL/SQL block.
   STATEMENT :=
         'BEGIN'
      || CHR (10)
      || ' SELECT '
      || sequencia
      || '.nextval'
      || CHR (10)
      || ' INTO :id_value'
      || CHR (10)
      || ' FROM dual;'
      || CHR (10)
      || 'END;';

   EXECUTE IMMEDIATE STATEMENT
               USING OUT id_value;

   RETURN id_value;
END "generar_clau_primaria";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
FUNCTION "generar_where_clause" (
   columnes    IN   NVARCHAR2,
   valors      IN   NVARCHAR2,
   nom_taula   IN   NVARCHAR2
)
   RETURN VARCHAR2
AS
   v_num                  NUMBER          := 0;
   v_num3                 NUMBER          := 0;
   v_len                  NUMBER          := 0;
   v_len3                 NUMBER          := 0;
   v_inc                  NUMBER          := 0;
   v_inc3                 NUMBER          := 0;
   v_str                  VARCHAR2 (100);
   v_str3                 VARCHAR2 (100);
   v_sql1                 VARCHAR2 (1000);
   v_sql2                 VARCHAR2 (1000);
   v_sql4                 VARCHAR2 (1000);
   v_sql5                 VARCHAR2 (1000);
   where_clause           VARCHAR2 (2000) := 'where';
   tipus_columna          VARCHAR (30);
   valor_columna_number   NUMBER;
   valor_columna_date     DATE;
BEGIN
   SELECT LENGTH (columnes)
     INTO v_len
     FROM DUAL;

   SELECT LENGTH (valors)
     INTO v_len3
     FROM DUAL;

   WHILE (v_num <= v_len)
   LOOP
      v_sql1 :=
            'select instr(substr('''
         || columnes
         || ''', ( '
         || v_num
         || ' + 1 ),'
         || v_len
         || '),'
         || ''' '''
         || ') from dual';

      EXECUTE IMMEDIATE v_sql1
                   INTO v_inc;

      v_sql4 :=
            'select instr(substr('''
         || valors
         || ''', ( '
         || v_num3
         || ' + 1 ),'
         || v_len3
         || '),'
         || ''' '''
         || ') from dual';

      EXECUTE IMMEDIATE v_sql4
                   INTO v_inc3;

      IF (v_inc = 0)
      THEN
         v_inc := v_len - v_num + 1;
      END IF;

      IF (v_inc3 = 0)
      THEN
         v_inc3 := v_len3 - v_num3 + 1;
      END IF;

      v_sql2 :=
            'select substr('''
         || columnes
         || ''', ( '
         || v_num
         || ' + 1 ),( '
         || v_inc
         || ' - 1 )) from dual';
      v_sql5 :=
            'select substr('''
         || valors
         || ''', ( '
         || v_num3
         || ' + 1 ),( '
         || v_inc3
         || ' - 1 )) from dual';

      EXECUTE IMMEDIATE v_sql2
                   INTO v_str;

      EXECUTE IMMEDIATE v_sql5
                   INTO v_str3;

      tipus_columna := "tipus_columna" (nom_taula, v_str);

      IF (tipus_columna = 'NUMBER')
      THEN
         valor_columna_number := TO_NUMBER (v_str3);
         where_clause :=
               where_clause
            || ' '
            || '"'
            || v_str
            || '"'
            || '='
            || valor_columna_number;
       --ELSIF (tipus_columna='DATE')
       --THEN
      -- where_clause:= where_clause || ' ' || '"'||v_str ||'"'|| '= to_date(v_str3,'DD-MM-YYYY')';
      ELSE
         where_clause :=
                  where_clause || ' ' || '"' || v_str || '"' || '=' || v_str3;
      END IF;

      v_num := v_num + v_inc;
      v_num3 := v_num3 + v_inc3;
   END LOOP;

   RETURN where_clause;
END "generar_where_clause";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
FUNCTION "nom_clau_primaria" (nom_taula IN VARCHAR2)
   RETURN NVARCHAR2
AS
   nom_clau   NVARCHAR2 (50);
BEGIN
   SELECT cols.column_name
     INTO nom_clau
     FROM user_constraints cons, user_cons_columns cols
    WHERE cons.constraint_type = 'P'
      AND cons.constraint_name = cols.constraint_name
      AND cols.table_name LIKE LOWER (nom_taula);

   RETURN nom_clau;
END "nom_clau_primaria";
/


CREATE OR REPLACE /* Formatted on 2011/12/13 16:17 (Formatter Plus v4.8.8) */
FUNCTION "tipus_columna" (nom_taula IN NVARCHAR2, nom_columna IN NVARCHAR2)
   RETURN VARCHAR2
AS
   tipus_columna   VARCHAR2 (30);
BEGIN
   SELECT data_type
     INTO tipus_columna
     FROM user_tab_columns
    WHERE table_name LIKE LOWER (nom_taula)
      AND column_name LIKE LOWER (nom_columna);

   RETURN tipus_columna;
END "tipus_columna";
/


Exec dbms_utility.compile_schema (schema=>'manteniment', compile_all => true);

