


-- Create Tables section


Create table "F_REPARACIONS" (
	"REPARACIONS_DINS_TERMINI" Number,
	"REPARACIONS_FORA_TERMINI" Number,
	"ID_TEMPS" Number NOT NULL ,
	"ID_EMPRESA_MANTENIMENT" Number NOT NULL ,
	"ID_APARELL" Number NOT NULL ,
	"ID_PRIORITAT" Number NOT NULL ,
primary key ("ID_TEMPS","ID_EMPRESA_MANTENIMENT","ID_APARELL","ID_PRIORITAT") 
) 
/

Create table "F_MANTENIMENTS" (
	"MANTENIMENTS_REALITZATS" Number,
	"MANTENIMENTS_NO_REALITZATS" Number,
	"ID_TEMPS" Number NOT NULL ,
	"ID_EMPRESA_MANTENIMENT" Number NOT NULL ,
	"ID_APARELL" Number NOT NULL ,
primary key ("ID_TEMPS","ID_EMPRESA_MANTENIMENT","ID_APARELL") 
) 
/

Create table "D_TEMPS" (
	"ID_TEMPS" Number NOT NULL ,
	"SETMANA" Varchar2 (20),
	"MES" Varchar2 (20),
	"YEAR" Varchar2 (4 CHAR),
primary key ("ID_TEMPS") 
) 
/

Create table "D_EMPRESA_MANTENIMENT" (
	"ID_EMPRESA_MANTENIMENT" Number NOT NULL ,
	"NOM_EMPRESA" Varchar2 (40) NOT NULL ,
	"NIF" Varchar2 (9 CHAR) NOT NULL ,
primary key ("ID_EMPRESA_MANTENIMENT") 
) 
/

Create table "D_PRIORITAT" (
	"ID_PRIORITAT" Number NOT NULL ,
	"PRIORITAT" Varchar2 (40) NOT NULL ,
primary key ("ID_PRIORITAT") 
) 
/

Create table "D_APARELL" (
	"ID_APARELL" Number NOT NULL ,
	"MARCA" Varchar2 (40) NOT NULL ,
	"MODEL" Varchar2 (50) NOT NULL ,
	"TIPUS_APARELL" Varchar2 (40) NOT NULL ,
	"ID_APARELL_OPERACIONAL" Number NOT NULL ,
primary key ("ID_APARELL") 
) 
/


-- Create Foreign keys section

Alter table "F_MANTENIMENTS" add  foreign key ("ID_TEMPS") references "D_TEMPS" ("ID_TEMPS") 
/

Alter table "F_REPARACIONS" add  foreign key ("ID_TEMPS") references "D_TEMPS" ("ID_TEMPS") 
/

Alter table "F_REPARACIONS" add  foreign key ("ID_EMPRESA_MANTENIMENT") references "D_EMPRESA_MANTENIMENT" ("ID_EMPRESA_MANTENIMENT") 
/

Alter table "F_MANTENIMENTS" add  foreign key ("ID_EMPRESA_MANTENIMENT") references "D_EMPRESA_MANTENIMENT" ("ID_EMPRESA_MANTENIMENT") 
/

Alter table "F_REPARACIONS" add  foreign key ("ID_PRIORITAT") references "D_PRIORITAT" ("ID_PRIORITAT") 
/

Alter table "F_REPARACIONS" add  foreign key ("ID_APARELL") references "D_APARELL" ("ID_APARELL") 
/

Alter table "F_MANTENIMENTS" add  foreign key ("ID_APARELL") references "D_APARELL" ("ID_APARELL") 
/



