

--otorgar privilegis de lectura a dw_manteniment sobre les taules

set serveroutput on;
set serveroutput on size 1000000;

DECLARE
vcount1 number := 0;
vcount2 number := 0;
v_tablename varchar2(32);
vschema varchar2(30) := 'manteniment';
vuser varchar2(30) := 'dw_manteniment';

BEGIN

vschema := UPPER(vschema);
vuser := UPPER(vuser);

for ctable in ( select owner, table_name from dba_tables where owner like vschema )
loop
vcount1:= vcount1+1;
v_tablename := ctable.table_name;
begin
dbms_output.put_line(ctable.owner||'."'||ctable.table_name||'"');
execute immediate 'grant select on "'||ctable.owner||'"."'||ctable.table_name||'" to '||vuser;
EXCEPTION -- exception handlers begin
WHEN OTHERS THEN -- handles all other errors
dbms_output.put_line('err_num: '||SQLCODE);
dbms_output.put_line('err_msg: '||SUBSTR(SQLERRM, 1, 100));
dbms_output.put_line('table_name: '||v_tablename);
vcount1:= vcount1-1;
END;
end loop;

dbms_output.put_line('-- ');
dbms_output.put_line('Counter Tables is: '||vcount1);
dbms_output.put_line('-- ');

END;
/


-- otorgar permisos d'execuci de procediments i funcions de consulta a dw_manteniment

set serveroutput on;
set serveroutput on size 1000000;

DECLARE
vcount1 number := 0;
vcount2 number := 0;
v_objectname varchar2(32);
vschema varchar2(30) := 'manteniment';
vuser varchar2(30) := 'dw_manteniment';


BEGIN

vschema := UPPER(vschema);
vuser := UPPER(vuser);

for cobject in (select owner, object_name from dba_procedures where owner like vschema and object_name like '%consulta%')
loop
vcount1:= vcount1+1;
v_objectname := cobject.object_name;
begin
dbms_output.put_line(cobject.owner||'."'||cobject.object_name||'"');
execute immediate 'grant execute on "'||cobject.owner||'"."'||cobject.object_name||'" to '||vuser;
EXCEPTION -- exception handlers begin
WHEN OTHERS THEN -- handles all other errors
dbms_output.put_line('err_num: '||SQLCODE);
dbms_output.put_line('err_msg: '||SUBSTR(SQLERRM, 1, 100));
dbms_output.put_line('object_name: '||v_objectname);
vcount1:= vcount1-1;
END;
end loop;

dbms_output.put_line('-- ');
dbms_output.put_line('Counter objects is: '||vcount1);
dbms_output.put_line('-- ');

END;
/

-- otorgar permisos al paquet MANTENIMENT."consultes_cursors"

GRANT EXECUTE ON MANTENIMENT."consultes_cursors" TO dw_manteniment;