--
-- Drop and Create Script 
--   Database Version   : 10.2.0.1.0 
--   TOAD Version       : 9.0.0.160 
--   DB Connect String  : XE 
--   Schema             : DW_MANTENIMENT 
--   Script Created by  : DW_MANTENIMENT 
--   Script Created at  : 13/12/2011 18:56:47 
--   Physical Location  :  
--   Notes              :  
--

-- Object Counts: 
--   Functions: 4       Lines of Code: 108 
--   Indexes: 6         Columns: 11         
--   Procedures: 11     Lines of Code: 437 
--   Sequences: 4 


DROP SEQUENCE SEQ_ID_APARELL
/

CREATE SEQUENCE SEQ_ID_APARELL
  START WITH 41
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


DROP SEQUENCE SEQ_ID_EMPRESA_MANTENIMENT
/

CREATE SEQUENCE SEQ_ID_EMPRESA_MANTENIMENT
  START WITH 41
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


DROP SEQUENCE SEQ_ID_PRIORITAT
/

CREATE SEQUENCE SEQ_ID_PRIORITAT
  START WITH 41
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


DROP SEQUENCE SEQ_ID_TEMPS
/

CREATE SEQUENCE SEQ_ID_TEMPS
  START WITH 1141
  MAXVALUE 999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  CACHE 20
  NOORDER
/


DROP PROCEDURE ESBORRAR_MANTENIMENT_PREVENTIU
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "ESBORRAR_MANTENIMENT_PREVENTIU" (id_aparell_baixa IN NUMBER)
AS
   year_actual       VARCHAR2 (4 CHAR)  := TO_CHAR (SYSDATE, 'YYYY');
   mes_actual        VARCHAR2 (10 CHAR)
               := TO_CHAR (SYSDATE, 'FMMONTH', 'NLS_DATE_LANGUAGE = CATALAN');
   numero_mes        NUMBER             := TO_CHAR (SYSDATE, 'MM');
   id_temps_actual   NUMBER;
BEGIN
   SELECT "ID_TEMPS"
     INTO id_temps_actual
     FROM "D_TEMPS"
    WHERE "ID_TEMPS" = (SELECT "ID_TEMPS"
                          FROM "D_TEMPS"
                         WHERE "MES" = mes_actual AND "YEAR" = year_actual);

   MERGE INTO "F_MANTENIMENTS"
      USING DUAL d
      ON (    "F_MANTENIMENTS"."ID_TEMPS" > id_temps_actual
          AND "ID_APARELL" = id_aparell_baixa)
      WHEN MATCHED THEN
         UPDATE
            SET "MANTENIMENTS_REALITZATS" = NULL,
                "MANTENIMENTS_NO_REALITZATS" = NULL, "ID_TEMPS" = NULL,
                "ID_EMPRESA_MANTENIMENT" = NULL, "ID_APARELL" = NULL
         ;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "ESBORRAR_MANTENIMENT_PREVENTIU";
/

SHOW ERRORS;


DROP PROCEDURE INSERIR_ANY
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "INSERIR_ANY"
AS
   any_char    VARCHAR2 (4 CHAR) := TO_CHAR (SYSDATE, 'YYYY');
   any_inici   NUMBER            := TO_NUMBER (any_char);
   any_final   NUMBER            := any_inici + 5;
   id_taula    NUMBER;
BEGIN
   FOR any_actual IN any_inici .. any_final
   LOOP
      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'GENER', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'FEBRER', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'MAR', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'ABRIL', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'MAIG', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'JUNY', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'JULIOL', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'AGOST', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'SETEMBRE', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'OCTUBRE', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'NOVEMBRE', TO_CHAR (any_actual)
                  );

      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

      INSERT INTO "D_TEMPS"
                  ("ID_TEMPS", "MES", "YEAR"
                  )
           VALUES (id_taula, 'DESEMBRE', TO_CHAR (any_actual)
                  );

      FOR i IN 1 .. 53
      LOOP
         id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_TEMPS');

         INSERT INTO "D_TEMPS"
                     ("ID_TEMPS", "SETMANA", "YEAR"
                     )
              VALUES (id_taula, TO_CHAR (i), TO_CHAR (any_actual)
                     );
      END LOOP;
   END LOOP;
END "INSERIR_ANY";
/

SHOW ERRORS;


DROP PROCEDURE INSERIR_REQUERIMENT_PREVENTIU
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "INSERIR_REQUERIMENT_PREVENTIU" (
   id_empresa_in     IN   NUMBER,
   id_aparell_in     IN   NUMBER,
   periocitat        IN   VARCHAR2,
   data_inici_mant        DATE,
   data_fi_mant           DATE
)
AS
   year_actual       VARCHAR2 (4 CHAR)  := TO_CHAR (SYSDATE, 'YYYY');
   year_final        VARCHAR2 (4 CHAR)  := TO_CHAR (data_fi_mant, 'YYYY');
   mes_actual        VARCHAR2 (10 CHAR)
               := TO_CHAR (SYSDATE, 'FMMONTH', 'NLS_DATE_LANGUAGE = CATALAN');
   numero_mes        NUMBER             := TO_CHAR (SYSDATE, 'MM');
   mes_contador      NUMBER;
   id_temps_actual   NUMBER;
BEGIN
   CASE
      WHEN UPPER (periocitat) LIKE 'MENSUAL'
      THEN
         FOR m IN numero_mes .. 12
         LOOP
            mes_actual :=
               TO_CHAR (TO_DATE (TO_CHAR (m), 'MM'),
                        'FMMONTH',
                        'NLS_DATE_LANGUAGE = CATALAN'
                       );

            FOR y IN year_actual .. year_final
            LOOP
               SELECT "ID_TEMPS"
                 INTO id_temps_actual
                 FROM "D_TEMPS"
                WHERE "MES" = mes_actual AND "YEAR" = y;

               IF (data_fi_mant <
                                TO_DATE (TO_CHAR (m) || TO_CHAR (y),
                                         'MM-YYYY')
                  )
               THEN
                  MERGE INTO "F_MANTENIMENTS"
                     USING DUAL d
                     ON ("F_MANTENIMENTS"."ID_TEMPS" = id_temps_actual)
                     WHEN MATCHED THEN
                        UPDATE
                           SET "MANTENIMENTS_REALITZATS" = 0,
                               "MANTENIMENTS_NO_REALITZATS" =
                                             "MANTENIMENTS_NO_REALITZATS" + 1
                     WHEN NOT MATCHED THEN
                        INSERT ("MANTENIMENTS_REALITZATS",
                                "MANTENIMENTS_NO_REALITZATS", "ID_TEMPS",
                                "ID_EMPRESA_MANTENIMENT", "ID_APARELL")
                        VALUES (0, 1, id_temps_actual, id_empresa_in,
                                id_aparell_in);
               END IF;
            END LOOP;
         END LOOP;
      WHEN UPPER (periocitat) LIKE 'BIMENSUAL'
      THEN
         mes_contador := numero_mes;

         WHILE mes_contador < 12
         LOOP
            mes_actual :=
               TO_CHAR (TO_DATE (TO_CHAR (mes_contador), 'MM'),
                        'FMMONTH',
                        'NLS_DATE_LANGUAGE = CATALAN'
                       );

            FOR y IN year_actual .. year_final
            LOOP
               SELECT "ID_TEMPS"
                 INTO id_temps_actual
                 FROM "D_TEMPS"
                WHERE "MES" = mes_actual AND "YEAR" = y;

               IF (data_fi_mant <
                      TO_DATE (TO_CHAR (mes_contador) || TO_CHAR (y),
                               'MM-YYYY')
                  )
               THEN
                  MERGE INTO "F_MANTENIMENTS"
                     USING DUAL d
                     ON ("F_MANTENIMENTS"."ID_TEMPS" = id_temps_actual)
                     WHEN MATCHED THEN
                        UPDATE
                           SET "MANTENIMENTS_REALITZATS" = 0,
                               "MANTENIMENTS_NO_REALITZATS" =
                                             "MANTENIMENTS_NO_REALITZATS" + 1
                     WHEN NOT MATCHED THEN
                        INSERT ("MANTENIMENTS_REALITZATS",
                                "MANTENIMENTS_NO_REALITZATS", "ID_TEMPS",
                                "ID_EMPRESA_MANTENIMENT", "ID_APARELL")
                        VALUES (0, 1, id_temps_actual, id_empresa_in,
                                id_aparell_in);
               END IF;
            END LOOP;

            mes_contador := mes_contador + 2;
         END LOOP;
      WHEN UPPER (periocitat) LIKE 'TRIMESTRAL'
      THEN
         mes_contador := numero_mes;

         WHILE mes_contador < 12
         LOOP
            mes_actual :=
               TO_CHAR (TO_DATE (TO_CHAR (mes_contador), 'MM'),
                        'FMMONTH',
                        'NLS_DATE_LANGUAGE = CATALAN'
                       );

            FOR y IN year_actual .. year_final
            LOOP
               SELECT "ID_TEMPS"
                 INTO id_temps_actual
                 FROM "D_TEMPS"
                WHERE "MES" = mes_actual AND "YEAR" = y;

               IF (data_fi_mant <
                      TO_DATE (TO_CHAR (mes_contador) || TO_CHAR (y),
                               'MM-YYYY')
                  )
               THEN
                  MERGE INTO "F_MANTENIMENTS"
                     USING DUAL d
                     ON ("F_MANTENIMENTS"."ID_TEMPS" = id_temps_actual)
                     WHEN MATCHED THEN
                        UPDATE
                           SET "MANTENIMENTS_REALITZATS" = 0,
                               "MANTENIMENTS_NO_REALITZATS" =
                                             "MANTENIMENTS_NO_REALITZATS" + 1
                     WHEN NOT MATCHED THEN
                        INSERT ("MANTENIMENTS_REALITZATS",
                                "MANTENIMENTS_NO_REALITZATS", "ID_TEMPS",
                                "ID_EMPRESA_MANTENIMENT", "ID_APARELL")
                        VALUES (0, 1, id_temps_actual, id_empresa_in,
                                id_aparell_in);
               END IF;
            END LOOP;

            mes_contador := mes_contador + 3;
         END LOOP;
      WHEN UPPER (periocitat) LIKE 'SEMESTRAL'
      THEN
         mes_contador := numero_mes;

         WHILE mes_contador < 12
         LOOP
            mes_actual :=
               TO_CHAR (TO_DATE (TO_CHAR (mes_contador), 'MM'),
                        'FMMONTH',
                        'NLS_DATE_LANGUAGE = CATALAN'
                       );

            FOR y IN year_actual .. year_final
            LOOP
               SELECT "ID_TEMPS"
                 INTO id_temps_actual
                 FROM "D_TEMPS"
                WHERE "MES" = mes_actual AND "YEAR" = y;

               IF (data_fi_mant <
                      TO_DATE (TO_CHAR (mes_contador) || TO_CHAR (y),
                               'MM-YYYY')
                  )
               THEN
                  MERGE INTO "F_MANTENIMENTS"
                     USING DUAL d
                     ON ("F_MANTENIMENTS"."ID_TEMPS" = id_temps_actual)
                     WHEN MATCHED THEN
                        UPDATE
                           SET "MANTENIMENTS_REALITZATS" = 0,
                               "MANTENIMENTS_NO_REALITZATS" =
                                             "MANTENIMENTS_NO_REALITZATS" + 1
                     WHEN NOT MATCHED THEN
                        INSERT ("MANTENIMENTS_REALITZATS",
                                "MANTENIMENTS_NO_REALITZATS", "ID_TEMPS",
                                "ID_EMPRESA_MANTENIMENT", "ID_APARELL")
                        VALUES (0, 1, id_temps_actual, id_empresa_in,
                                id_aparell_in);
               END IF;
            END LOOP;

            mes_contador := mes_contador + 6;
         END LOOP;
      WHEN UPPER (periocitat) LIKE 'ANUAL'
      THEN
         mes_contador := numero_mes;

         WHILE mes_contador < 12
         LOOP
            mes_actual :=
               TO_CHAR (TO_DATE (TO_CHAR (mes_contador), 'MM'),
                        'FMMONTH',
                        'NLS_DATE_LANGUAGE = CATALAN'
                       );

            FOR y IN year_actual .. year_final
            LOOP
               SELECT "ID_TEMPS"
                 INTO id_temps_actual
                 FROM "D_TEMPS"
                WHERE "MES" = mes_actual AND "YEAR" = y;

               IF (data_fi_mant <
                      TO_DATE (TO_CHAR (mes_contador) || TO_CHAR (y),
                               'MM-YYYY')
                  )
               THEN
                  MERGE INTO "F_MANTENIMENTS"
                     USING DUAL d
                     ON ("F_MANTENIMENTS"."ID_TEMPS" = id_temps_actual)
                     WHEN MATCHED THEN
                        UPDATE
                           SET "MANTENIMENTS_REALITZATS" = 0,
                               "MANTENIMENTS_NO_REALITZATS" =
                                             "MANTENIMENTS_NO_REALITZATS" + 1
                     WHEN NOT MATCHED THEN
                        INSERT ("MANTENIMENTS_REALITZATS",
                                "MANTENIMENTS_NO_REALITZATS", "ID_TEMPS",
                                "ID_EMPRESA_MANTENIMENT", "ID_APARELL")
                        VALUES (0, 1, id_temps_actual, id_empresa_in,
                                id_aparell_in);
               END IF;
            END LOOP;

            mes_contador := mes_contador + 12;
         END LOOP;
   END CASE;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "INSERIR_REQUERIMENT_PREVENTIU";
/

SHOW ERRORS;


DROP PROCEDURE OMPLIR_D_APARELLS
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "OMPLIR_D_APARELLS"
AS
   CURSOR c_aparells_per_inserir
   IS
      SELECT apa."id_aparell", apa."marca", apa."model", tip."nom"
        FROM manteniment."aparell" apa, manteniment."tipus_aparell" tip
       WHERE apa."id_tipus_aparell" = tip."id_tipus_aparell"
         AND apa."id_aparell" NOT IN (SELECT "ID_APARELL_OPERACIONAL"
                                        FROM "D_APARELL");

   id_taula   NUMBER;
BEGIN
   FOR l_aparells_per_inserir IN c_aparells_per_inserir
   LOOP
      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_APARELL');

      INSERT INTO "D_APARELL"
                  ("ID_APARELL", "MARCA",
                   "MODEL",
                   "TIPUS_APARELL",
                   "ID_APARELL_OPERACIONAL"
                  )
           VALUES (id_taula, l_aparells_per_inserir."marca",
                   l_aparells_per_inserir."model",
                   l_aparells_per_inserir."nom",
                   l_aparells_per_inserir."id_aparell"
                  );
   END LOOP;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "OMPLIR_D_APARELLS";
/

SHOW ERRORS;


DROP PROCEDURE OMPLIR_D_EMPRESA_MANTENIMENT
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "OMPLIR_D_EMPRESA_MANTENIMENT"
AS
   CURSOR c_empr_per_inserir
   IS
      SELECT emp."nom", emp."NIF"
        FROM manteniment."empresa_manteniment" emp
       WHERE emp."nom" NOT IN (SELECT "NOM_EMPRESA"
                                 FROM "D_EMPRESA_MANTENIMENT");

   id_taula   NUMBER;
BEGIN
   FOR l_empr_per_inserir IN c_empr_per_inserir
   LOOP
      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_EMPRESA_MANTENIMENT');

      INSERT INTO "D_EMPRESA_MANTENIMENT"
                  ("ID_EMPRESA_MANTENIMENT", "NOM_EMPRESA",
                   "NIF"
                  )
           VALUES (id_taula, l_empr_per_inserir."nom",
                   l_empr_per_inserir."NIF"
                  );
   END LOOP;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "OMPLIR_D_EMPRESA_MANTENIMENT";
/

SHOW ERRORS;


DROP PROCEDURE OMPLIR_D_PRIORITAT
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "OMPLIR_D_PRIORITAT"
AS
   CURSOR c_prioritat_per_inserir
   IS
      SELECT DISTINCT mant."prioritat"
                 FROM manteniment."manteniment_correctiu" mant
                WHERE mant."prioritat" NOT IN (SELECT "PRIORITAT"
                                                 FROM "D_PRIORITAT");

   id_taula   NUMBER;
BEGIN
   FOR l_prioritat_per_inserir IN c_prioritat_per_inserir
   LOOP
      id_taula := "GENERAR_CLAU_PRIMARIA" ('SEQ_ID_PRIORITAT');

      INSERT INTO "D_PRIORITAT"
                  ("ID_PRIORITAT", "PRIORITAT"
                  )
           VALUES (id_taula, l_prioritat_per_inserir."prioritat"
                  );
   END LOOP;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "OMPLIR_D_PRIORITAT";
/

SHOW ERRORS;


DROP PROCEDURE OMPLIR_D_TEMPS
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "OMPLIR_D_TEMPS"
AS
   any_actual_cerca   VARCHAR2 (4 CHAR);
   any_actual         VARCHAR2 (4 CHAR) := TO_CHAR (SYSDATE, 'YYYY');
   any_actual_mes_5   VARCHAR2 (4 CHAR)
                                       := TO_CHAR (TO_NUMBER (any_actual) + 5);
   id_taula           NUMBER;
BEGIN
   SELECT DISTINCT "YEAR"
              INTO any_actual_cerca
              FROM "D_TEMPS"
             WHERE "YEAR" LIKE any_actual;

   SELECT DISTINCT "YEAR"
              INTO any_actual_cerca
              FROM "D_TEMPS"
             WHERE "YEAR" LIKE any_actual_mes_5;
EXCEPTION
   WHEN NO_DATA_FOUND
   THEN
      "INSERIR_ANY" ();
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "OMPLIR_D_TEMPS";
/

SHOW ERRORS;


DROP PROCEDURE OMPLIR_F_MANTENIMENTS
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "OMPLIR_F_MANTENIMENTS"
AS
   CURSOR c_preventiu
   IS
      SELECT mant."id_aparell", mant."data_manteniment"
        FROM manteniment."manteniment_preventiu" mant
       WHERE TO_CHAR (mant."data_manteniment", 'DD-MM-YYYY') LIKE
                                          TO_CHAR (SYSDATE - 1, 'DD-MM-YYYY');

   id_aparell_inserir     NUMBER;
   id_temps_inserir_mes   NUMBER;
   id_empr_inserir        NUMBER;
   id_empr                NUMBER;
   es_dins_termini        BOOLEAN;
BEGIN
   id_temps_inserir_mes := "CERCAR_TEMPS_MES" ();
   "PRIMERA_INSERSIO_PREVENTIU" ();

   FOR l_preventiu IN c_preventiu
   LOOP
      SELECT "ID_APARELL"
        INTO id_aparell_inserir
        FROM "D_APARELL"
       WHERE "ID_APARELL_OPERACIONAL" = l_preventiu."id_aparell";

      SELECT "id_empr_mant"
        INTO id_empr
        FROM manteniment."contracte"
       WHERE "id_aparell" = l_preventiu."id_aparell"
         AND SYSDATE - 1 BETWEEN "data_inici" AND "data_fi";

      SELECT "ID_EMPRESA_MANTENIMENT"
        INTO id_empr_inserir
        FROM "D_EMPRESA_MANTENIMENT", manteniment."empresa_manteniment"
       WHERE "NOM_EMPRESA" = "empresa_manteniment"."nom"
         AND "empresa_manteniment"."id_empr_mant" = id_empr;

      UPDATE "F_MANTENIMENTS"
         SET "MANTENIMENTS_REALITZATS" = "MANTENIMENTS_REALITZATS" + 1,
             "MANTENIMENTS_NO_REALITZATS" = "MANTENIMENTS_NO_REALITZATS" - 1
       WHERE id_temps = id_temps_inserir_mes
         AND id_empresa_manteniment = id_empr_inserir
         AND id_aparell = id_aparell_inserir;
   END LOOP;
END "OMPLIR_F_MANTENIMENTS";
/

SHOW ERRORS;


DROP PROCEDURE OMPLIR_F_REPARACIONS
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "OMPLIR_F_REPARACIONS"
AS
   CURSOR c_correctiu
   IS
      SELECT mant."prioritat", mant."data_incidencia",
             mant."data_manteniment", mant."id_aparell", empr."nom"
        FROM manteniment."manteniment_correctiu" mant,
             manteniment."empresa_manteniment" empr
       WHERE mant."id_empr_mant" = empr."id_empr_mant"
         AND TO_CHAR (mant."data_manteniment", 'DD-MM-YYYY') LIKE
                                           TO_CHAR (SYSDATE - 1, 'DD-MM-YYYY');

   id_aparell_inserir         NUMBER;
   id_temps_inserir_setmana   NUMBER;
   id_temps_inserir_mes       NUMBER;
   id_empr_inserir            NUMBER;
   id_prioritat_inserir       NUMBER;
   es_dins_termini            BOOLEAN;
BEGIN
   id_temps_inserir_setmana := "CERCAR_TEMPS_SETMANA" ();
   id_temps_inserir_mes := "CERCAR_TEMPS_MES" ();

   FOR l_correctiu IN c_correctiu
   LOOP
      SELECT "ID_APARELL"
        INTO id_aparell_inserir
        FROM "D_APARELL"
       WHERE "ID_APARELL_OPERACIONAL" = l_correctiu."id_aparell";

      SELECT "ID_EMPRESA_MANTENIMENT"
        INTO id_empr_inserir
        FROM "D_EMPRESA_MANTENIMENT"
       WHERE "NOM_EMPRESA" = l_correctiu."nom";

      SELECT "ID_PRIORITAT"
        INTO id_prioritat_inserir
        FROM "D_PRIORITAT"
       WHERE "PRIORITAT" = l_correctiu."prioritat";

      es_dins_termini :=
         "DINS_TERMINI" (l_correctiu."data_incidencia",
                         l_correctiu."data_manteniment",
                         l_correctiu."prioritat"
                        );
      "PRIMERA_INSERSIO_REPARACIONS" (id_temps_inserir_setmana,
                                      id_temps_inserir_mes,
                                      id_aparell_inserir,
                                      id_empr_inserir,
                                      id_prioritat_inserir
                                     );

      IF es_dins_termini
      THEN
         UPDATE "F_REPARACIONS"
            SET "REPARACIONS_DINS_TERMINI" = "REPARACIONS_DINS_TERMINI" + 1
          WHERE id_temps = id_temps_inserir_setmana
            AND id_empresa_manteniment = id_empr_inserir
            AND id_aparell = id_aparell_inserir
            AND id_prioritat = id_prioritat_inserir;

         UPDATE "F_REPARACIONS"
            SET "REPARACIONS_DINS_TERMINI" = "REPARACIONS_DINS_TERMINI" + 1
          WHERE id_temps = id_temps_inserir_mes
            AND id_empresa_manteniment = id_empr_inserir
            AND id_aparell = id_aparell_inserir
            AND id_prioritat = id_prioritat_inserir;
      ELSE
         UPDATE "F_REPARACIONS"
            SET "REPARACIONS_FORA_TERMINI" = "REPARACIONS_FORA_TERMINI" + 1
          WHERE id_temps = id_temps_inserir_setmana
            AND id_empresa_manteniment = id_empr_inserir
            AND id_aparell = id_aparell_inserir
            AND id_prioritat = id_prioritat_inserir;

         UPDATE "F_REPARACIONS"
            SET "REPARACIONS_FORA_TERMINI" = "REPARACIONS_FORA_TERMINI" + 1
          WHERE id_temps = id_temps_inserir_mes
            AND id_empresa_manteniment = id_empr_inserir
            AND id_aparell = id_aparell_inserir
            AND id_prioritat = id_prioritat_inserir;
      END IF;
   END LOOP;
END "OMPLIR_F_REPARACIONS";
/

SHOW ERRORS;


DROP PROCEDURE PRIMERA_INSERSIO_PREVENTIU
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "PRIMERA_INSERSIO_PREVENTIU"
AS
   CURSOR c_aparell
   IS
      SELECT *
        FROM "D_APARELL" dapa, manteniment."aparell" apa
       WHERE dapa."ID_APARELL_OPERACIONAL" = apa."id_aparell"
         AND (apa."data_baixa" IS NULL OR apa."data_baixa" > SYSDATE - 1);

   CURSOR c_aparell_baixa
   IS
      SELECT *
        FROM "D_APARELL" dapa, manteniment."aparell" apa
       WHERE dapa."ID_APARELL_OPERACIONAL" = apa."id_aparell"
         AND apa."data_baixa" = SYSDATE - 1;

   CURSOR c_requeriment (tipus_aparell IN VARCHAR2)
   IS
      SELECT *
        FROM manteniment."requeriment_manteniment"
       WHERE "id_tipus_aparell" = tipus_aparell;

   id_empr                NUMBER;
   id_empr_inserir        NUMBER;
   id_tipus_aparell       NUMBER;
   id_temps_inserir_mes   NUMBER;
   data_inici_mant        DATE;
   data_fi_mant           DATE;
BEGIN
   id_temps_inserir_mes := "CERCAR_TEMPS_MES" ();

   FOR l_aparell IN c_aparell
   LOOP
      SELECT "id_empr_mant", "data_inici", "data_fi"
        INTO id_empr, data_inici_mant, data_fi_mant
        FROM manteniment."contracte"
       WHERE "id_aparell" = l_aparell."id_aparell"
         AND SYSDATE - 1 = "data_inici";

      SELECT "ID_EMPRESA_MANTENIMENT"
        INTO id_empr_inserir
        FROM "D_EMPRESA_MANTENIMENT", manteniment."empresa_manteniment"
       WHERE "NOM_EMPRESA" = "empresa_manteniment"."nom"
         AND "empresa_manteniment"."id_empr_mant" = id_empr;

      FOR l_requeriment IN c_requeriment (l_aparell."id_tipus_aparell")
      LOOP
         "INSERIR_REQUERIMENT_PREVENTIU" (id_empr_inserir,
                                          l_aparell."ID_APARELL",
                                          l_requeriment."periocitat",
                                          data_inici_mant,
                                          data_fi_mant
                                         );
      END LOOP;
   END LOOP;

   FOR l_aparell_baixa IN c_aparell_baixa
   LOOP
      "ESBORRAR_MANTENIMENT_PREVENTIU" (l_aparell_baixa."ID_APARELL");
   END LOOP;
EXCEPTION
   WHEN NO_DATA_FOUND
   THEN
      DBMS_OUTPUT.put_line ('No hi ha contractes nous de manteniment');
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "PRIMERA_INSERSIO_PREVENTIU";
/

SHOW ERRORS;


DROP PROCEDURE PRIMERA_INSERSIO_REPARACIONS
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
PROCEDURE "PRIMERA_INSERSIO_REPARACIONS" (
   id_temps_inserir_setmana   NUMBER,
   id_temps_inserir_mes       NUMBER,
   id_aparell_inserir         NUMBER,
   id_empr_inserir            NUMBER,
   id_prioritat_inserir       NUMBER
)
AS
   cerca   NUMBER;
BEGIN
   SELECT "ID_TEMPS"
     INTO cerca
     FROM "F_REPARACIONS"
    WHERE "ID_TEMPS" = id_temps_inserir_setmana
      AND "ID_APARELL" = id_aparell_inserir
      AND "ID_EMPRESA_MANTENIMENT" = id_empr_inserir
      AND "ID_PRIORITAT" = id_prioritat_inserir;

   IF cerca IS NULL
   THEN
      INSERT INTO "F_REPARACIONS"
                  (reparacions_dins_termini, reparacions_fora_termini,
                   id_temps, id_empresa_manteniment,
                   id_aparell, id_prioritat
                  )
           VALUES (0, 0,
                   id_temps_inserir_setmana, id_empr_inserir,
                   id_aparell_inserir, id_prioritat_inserir
                  );

      INSERT INTO "F_REPARACIONS"
                  (reparacions_dins_termini, reparacions_fora_termini,
                   id_temps, id_empresa_manteniment, id_aparell,
                   id_prioritat
                  )
           VALUES (0, 0,
                   id_temps_inserir_mes, id_empr_inserir, id_aparell_inserir,
                   id_prioritat_inserir
                  );
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "PRIMERA_INSERSIO_REPARACIONS";
/

SHOW ERRORS;


DROP FUNCTION CERCAR_TEMPS_MES
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
FUNCTION "CERCAR_TEMPS_MES"
   RETURN NUMBER
AS
   numero_year       VARCHAR2 (10);
   nom_mes           VARCHAR2 (10);
   id_temps_cercat   NUMBER;
BEGIN
   SELECT TO_CHAR (SYSDATE, 'YYYY')
     INTO numero_year
     FROM DUAL;

   SELECT TO_CHAR (SYSDATE, 'FMMONTH', 'NLS_DATE_LANGUAGE = CATALAN')
     INTO nom_mes
     FROM DUAL;

   SELECT id_temps
     INTO id_temps_cercat
     FROM d_temps
    WHERE mes LIKE nom_mes AND YEAR = TO_NUMBER (numero_year);

   RETURN id_temps_cercat;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "CERCAR_TEMPS_MES";
/

SHOW ERRORS;


DROP FUNCTION CERCAR_TEMPS_SETMANA
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
FUNCTION "CERCAR_TEMPS_SETMANA"
   RETURN NUMBER
AS
   numero_setmana    VARCHAR2 (10);
   numero_year       VARCHAR2 (10);
   numero_mes        VARCHAR2 (10);
   id_temps_cercat   NUMBER;
BEGIN
   SELECT TO_CHAR (SYSDATE, 'IW')
     INTO numero_setmana
     FROM DUAL;

   SELECT TO_CHAR (SYSDATE, 'YYYY')
     INTO numero_year
     FROM DUAL;

   SELECT TO_CHAR (SYSDATE, 'MM')
     INTO numero_mes
     FROM DUAL;

   IF ((TO_NUMBER (numero_mes) = 1) AND (TO_NUMBER (numero_setmana) > 5))
   THEN
      SELECT id_temps
        INTO id_temps_cercat
        FROM d_temps
       WHERE setmana = TO_NUMBER (numero_setmana)
         AND YEAR = TO_NUMBER (numero_year) - 1;
   ELSE
      SELECT id_temps
        INTO id_temps_cercat
        FROM d_temps
       WHERE setmana = TO_NUMBER (numero_setmana)
         AND YEAR = TO_NUMBER (numero_year);
   END IF;

   RETURN id_temps_cercat;
   RETURN NULL;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "CERCAR_TEMPS_SETMANA";
/

SHOW ERRORS;


DROP FUNCTION DINS_TERMINI
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
FUNCTION "DINS_TERMINI" (
   data_incidencia        IN   DATE,
   data_reparacio         IN   DATE,
   prioritat_incidencia   IN   VARCHAR2
)
   RETURN BOOLEAN
AS
   a_temps   BOOLEAN := FALSE;
BEGIN
   CASE prioritat_incidencia
      WHEN "DEF_PRIORITAT"."PRIORITAT_1"
      THEN
         IF ((data_incidencia - data_reparacio) <=
                                 "DEF_PRIORITAT"."TEMPS_RESOLUCIO_PRIOTITAT_1"
            )
         THEN
            a_temps := TRUE;
         END IF;
      WHEN "DEF_PRIORITAT"."PRIORITAT_2"
      THEN
         IF ((data_incidencia - data_reparacio) <=
                                 "DEF_PRIORITAT"."TEMPS_RESOLUCIO_PRIOTITAT_2"
            )
         THEN
            a_temps := TRUE;
         END IF;
      WHEN "DEF_PRIORITAT"."PRIORITAT_3"
      THEN
         IF ((data_incidencia - data_reparacio) <=
                                 "DEF_PRIORITAT"."TEMPS_RESOLUCIO_PRIOTITAT_3"
            )
         THEN
            a_temps := TRUE;
         END IF;
      WHEN "DEF_PRIORITAT"."PRIORITAT_4"
      THEN
         IF ((data_incidencia - data_reparacio) <=
                                 "DEF_PRIORITAT"."TEMPS_RESOLUCIO_PRIOTITAT_4"
            )
         THEN
            a_temps := TRUE;
         END IF;
   END CASE;

   RETURN a_temps;
EXCEPTION
   WHEN OTHERS
   THEN
      raise_application_error (-20001, SQLERRM);
END "DINS_TERMINI";
/

SHOW ERRORS;


DROP FUNCTION GENERAR_CLAU_PRIMARIA
/

CREATE OR REPLACE /* Formatted on 2011/12/13 18:56 (Formatter Plus v4.8.8) */
FUNCTION "GENERAR_CLAU_PRIMARIA" (nom_sequencia IN VARCHAR2)
   RETURN NUMBER
IS
   PRAGMA AUTONOMOUS_TRANSACTION;
   id_value    NUMBER;
   STATEMENT   VARCHAR2 (2000);
   sequencia   NVARCHAR2 (50);
BEGIN
   sequencia := dbms_assert.enquote_name ('"' || nom_sequencia || '"');
-- Build and run dynamic SQL in a PL/SQL block.
   STATEMENT :=
         'BEGIN'
      || CHR (10)
      || ' SELECT '
      || sequencia
      || '.nextval'
      || CHR (10)
      || ' INTO :id_value'
      || CHR (10)
      || ' FROM dual;'
      || CHR (10)
      || 'END;';

   EXECUTE IMMEDIATE STATEMENT
               USING OUT id_value;

   RETURN id_value;
END "GENERAR_CLAU_PRIMARIA";
/

SHOW ERRORS;


